// from my mira #4c and ocular-06
// chaotic trajectory with sliders
// code frags: xforms, mira, coloring
// try puff(N++) for speed control

//GLOBALS ======================================

// frrom ocular-06
var sine; // sine generator enough for now
var freq = 440; //format of sprott3D mp4s

// from mira 4c
var msg;
var a; // to hold slider value
var b; // to hold slider value
var final = 40000; // length of trajectory
var initial = 2000; // inital puff
var p = 2000; // increment for number to puff in each frame
var n = initial; // number to puff

// MATH COORDS (u, v)
//init conditions
var u0 = 0.0; 
var v0 = 0.0;
// the mira domain (unit square)
var umin = -2.0;
var umax = 1.6;
var vmin = -1.8;
var vmax = 2.5;
var udelta = umax - umin;
var vdelta = vmax - vmin;
// math coords for trajectory with init values
var unow = u0;
var vnow = v0;
var unext = unew(unow, vnow);
var vnext = vnew(unow, vnow);
// new text test

// CANVAS COORDS (x, y)
// canvas size, (0, 0) to (500, 500)
var h = 500;
var w = 500;
// canvas coords for trajectry
var xnow = xcanvas(unow);
var ynow = ycanvas(vnow);
var xnext = xcanvas(unext);
var ynext = ycanvas(vnext);

// drawing routines
function plot(n) {
	// reset inits
	unow = u0; 
	vnow = v0;
	// now iterate
	for (var i=0; i < n; i++) {
		// iterate
		unext = unew(unow, vnow);
		vnext = vnew(unow, vnow);
		// get color
		var distnow = distance(unext, vnext, unow, vnow);
		colornew(distnow);
		// fill(colornow);
		// convert
		xnext = xcanvas(unext, width);
		ynext = ycanvas(vnext, height);
		// display
		rect(xnext, ynext, 1, 1);  // small red dot 
		//swappo
		unow = unext;
		vnow = vnext;
		// clipping
		if (unow < -1.8) { unow = -1.7 };
		if (unow > 1.8) { unow = 1.7 };
		if (vnow < -1.8) { vnow = -1.7 };
		if (vnow > 1.8) { vnow = 1.7 };
	}
}

// begin usual sketch code ======================
function setup() {
	// set canvas
	createCanvas(w, h);
	background(200); // 20% gray
	// sound
	sine = new p5.SinOsc();
	sine.amp(0.0);
	sine.start();
	//plot init
	fill(0); // black, for initial point
	ellipse(xnow, ynow, 5, 5); // small circular dot
	// plot trajectory
	noStroke();
	// for text
	textFont("Arial");
	textSize(24);
} // end setup

function draw() {
	background(200); // clear the canvas to gray
	// a = 0.7; // default params
	// b = -0.8;
	// set speed
	frameRate = 10;
	
		
	// toggle plot and image
	if (keyIsPressed) {
		
		// switch block
		switch(key) {
		case 'a':
			C();
			break;
		case 's':
			D();
			break;
		case 'd':
			E();
			break;
		case 'f':
			F();
			break;
		case 'g':
			G();
			break;
		case 'h':
			A();
			break;
		case 'j':
			B();
			break;
		case 'k':
			C5();
			break;
		case 'q':
			sine.amp(0.0); // do mute
			break;
		} // end switch block
		
			// go plot
		if ( n < final) {
			plot(n); // draw trajectory
			n += p; // increment number to puff
		} else {
			plot(final);
		}

		// sound
		sine.amp(0.5); // undo mute
			}
	else {
		sine.amp(0.0); // do mute
	}
}


// end of sketch
